# include <math.h>
# include <stdio.h>
# include <stdlib.h>
# include <GL/glut.h>

# include "Rocket.h"


Rocket::Rocket() : x(0.0f), y(0.0f), theta(0.0f), timeLeft(0.0f)
{

}



void Rocket::Shoot()
{
	if(timeLeft <= 0.0f)
	timeLeft = 0.25f;
}



Point Rocket::Translate(float x1, float y1)
{
    Point p;

    p.x = x + x1;
    p.y = y + y1;

    return p;
}



Point Rocket::Rotate(float x, float y)
{
    Point p;

    p.x = x*cos(theta) - y*sin(theta);
    p.y = x*sin(theta) + y*cos(theta);

    return p;
}


void Rocket::Draw()
{
	if(timeLeft > 0.0f)
		shootingTexture.Activate();
	else
		idleTexture.Activate();

	const float size = 0.125f;

    glBegin(GL_TRIANGLE_STRIP);

	Point p = {0.0f, 0.0f};

    glTexCoord2f(0.0f, 0.0f);
    p = Rotate(-size, -size);
    p = Translate(p.x, p.y);
    glVertex2f(p.x, p.y);

    glTexCoord2f(1.0f, 0.0f);
    p = Rotate( size, -size);
    p = Translate(p.x, p.y);
    glVertex2f(p.x, p.y);


    glTexCoord2f(0.0f, 1.0f);
    p = Rotate(-size,  size);
    p = Translate(p.x, p.y);
    glVertex2f(p.x, p.y);

    glTexCoord2f(1.0f, 1.0f);
    p = Rotate( size,  size);
    p = Translate(p.x, p.y);
    glVertex2f(p.x, p.y);

    glEnd();
}




void Rocket::Init()
{
	idleTexture.Init("rocket.tga");
	shootingTexture.Init("rocket_firing.tga");
}



void Rocket::OnMouseMove(float x1, float y1)
{
	x1 -= x;
    y1 -= y;
    theta = atan2(y1, x1);
}


void Rocket::Update(float deltaTime)
{
	timeLeft -= deltaTime;
}