/*
This programs tells you how to rotate images at a point other than origin.
click inisde to window to change the point of rotation

NOTE:
This tutorial tells you what is the method to rotate an image at some point.
This is not the cleanest/fastest way to do so.
You can simply call some SDK functions to do so; but its nice if you understand
what happens inside those functions.
      
*/

# include <math.h>
# include <stdio.h>
# include <stdlib.h>
# include <GL/glut.h>

# include "Rocket.h"


Rocket rocket;


float theta = 22.0f/14.0f;
int windowWidth = 800;
int windowHeight = 800;


void OnWindowResize(int width, int height)
{
    glViewport(0, 0, width, height);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

    windowWidth = width;
    windowHeight = height;
}


void OnKeyPress(unsigned char key, int x, int y)
{
# define ESC_Key 27

    switch (key)
    {
        case ESC_Key:
            exit(0);
        break;
    }
}


void Draw()
{
	static DWORD lastTime = GetTickCount();
	DWORD now = GetTickCount();

	float deltaTime = float(now - lastTime)/1000.0f;
	rocket.Update(deltaTime);
	lastTime = now;

    glClearColor(0.1f, 0.1f, 0.5f, 0.0f);
    glClear(GL_COLOR_BUFFER_BIT);


	glEnable (GL_BLEND);
	glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    
    rocket.Draw();

    glutSwapBuffers();

}


void OnMouseMove(int mouseX, int mouseY)
{
    //Convert mouseX, mouseY into (x, y)
    //where x and y values are between -1 and +1
    float x = (float) (2.0f*mouseX)/(float)windowWidth - 1.0f;
    float y = 1.0f - (float)(2.0f*mouseY)/(float)windowHeight;

	rocket.OnMouseMove(x, y);

    glutPostRedisplay();
}


void OnMouseClick(int button, int state, int x, int y)
{
	if(state == GLUT_DOWN)
		rocket.Shoot();

    glutPostRedisplay();
}

int main(int argc, char** argv)
{
    const int left = 0;
    const int top = 0;

    const char* windowTitle = "Asteorids";

    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE);
    glutInitWindowSize(windowWidth, windowHeight); 
    glutInitWindowPosition(left, top);
    glutCreateWindow(windowTitle);
    
    glutDisplayFunc(Draw);
    glutReshapeFunc(OnWindowResize);
    glutKeyboardFunc(OnKeyPress);
    glutMouseFunc(OnMouseClick);
    glutIdleFunc(Draw);
    glutPassiveMotionFunc(OnMouseMove);

    rocket.Init();


    glutMainLoop();

    return 0;
}