# ifndef ROCKET_H
# define ROCKET_H

# include "TgaTexture.h"
# include "MissileManager.h"


struct Point
{
    float x,y;
};


class Rocket
{
	float x;
	float y;
	float theta;
	float timeLeft;

	TgaTexture		idleTexture;
	TgaTexture		shootingTexture;
	MissileManager	missileManager;

	Point Translate(float x1, float y1);
	Point Rotate(float x1, float y1);

	void DrawMissile();

public:

	Rocket();

	void Init();

	void Draw();
	
	void Update(float deltaTime);

	void Shoot();

	void OnMouseMove(float x1, float y1);

	void Relocate(float x1, float y1);

};
# endif //ROCKET_H