# include <math.h>

# include "Asteroid.h"
# include "TgaTexture.h"



float GetRandomValue(float min, float max)
{
	int number = rand();
	float value = float(number) / float(RAND_MAX);

	return min + value*(max-min);
}

int GetRandom(int limit)
{
	return rand() % limit;
}


Asteroid::Asteroid()
{
	Reset();
}


void Asteroid::Reset()
{
	dx = GetRandomValue(0.1f, 0.25f);
	dy = -GetRandomValue(0.1f, 0.25f);

	y = 1.1f;

	x = GetRandomValue(0.0f, 1.0f);

	if(GetRandom(10) > 5) x = -x;
	else dx = -dx;

	theta = GetRandomValue(-4.0f, 4.0f);

	color = GetRandom(6);
	size = GetRandomValue(0.05f, 0.1f);
}


bool Asteroid::Update(float deltaTime)
{
	theta += deltaTime*size*10.0f; 

	float speed = 0.5f;
	x += dx*speed*deltaTime;
	y += dy*speed*deltaTime;
	
	const float left = x - size;
	const float right = x + size;
	const float top = y + size;
	const float bottom = y - size;

	if(fabs(x) + fabs(y) > 3.0f) Reset();

	return false;
}


void Asteroid::Draw()
{
	float colors[6][3] =
	{
		{0.75f, 0.25f, 0.25f},
		{0.25f, 0.75f, 0.25f},
		{0.25f, 0.25f, 0.75f},
		{0.25f, 0.75f, 0.75f},
		{0.75f, 0.25f, 0.75f},
		{0.75f, 0.75f, 0.25f},
	};

	glColor3f(colors[color][0], colors[color][1], colors[color][2]);
	TgaTexture::DrawQuad(x, y, size, size, theta);
}