# ifndef TGA_TEXTURE_H
# define TGA_TEXTURE_H

# include <stdio.h>
# include <stdlib.h>
# include <GL/glut.h>


struct Point
{
    float x,y;
};


class TgaTexture
{
    GLuint m_TextureHandle;
    unsigned char *m_pPixelBuffer;

    GLenum m_iBpp;  //bytes per pixel

	

	static void Vertex(float x, float y, float dx, float dy, float theta);


public:
    int Width;
    int Height;

    TgaTexture();
    ~TgaTexture();

    bool Init(const char *fileName);
    void Activate();
    void Destroy();
	static void DrawQuad(float x, float y, float sizeX, float sizeY, float theta = 0.0f);
};

# endif //TGA_TEXTURE_H