# include "Utils.h"
# include "SpaceShip.h"
# include "TgaTexture.h"


static float spaceShipSize = 0.125f;

SpaceShip::SpaceShip()
{
	Reset();
}


void SpaceShip::Reset()
{
	if(GetRandom(2))
	{
		x = GetRandomValue(-1.0f, 1.0f);
		y = 1.0f + spaceShipSize;
		if(GetRandom(2)) y = -y;
	}
	else
	{
		y = GetRandomValue(-1.0f, 1.0f);
		x = 1.0f + spaceShipSize;
		if(GetRandom(2)) x = -x;
	}

	dx = GetRandomValue(0.5f, 1.0f);
	dy = GetRandomValue(0.5f, 1.0f);

	if(x > 0.0f) dx = -dx;
	if(y > 0.0f) dy = -dy;

	color = GetRandom(3);
}


void SpaceShip::Update(float deltaTime)
{
	float speed = 0.5f;
	x += dx*speed*deltaTime;
	y += dy*speed*deltaTime;
	
	const float left = x - spaceShipSize;
	const float right = x + spaceShipSize;
	const float top = y + spaceShipSize;
	const float bottom = y - spaceShipSize;
	const float offset = 1.1f;

	if(left > offset) Reset();
	else if(right < -offset) Reset();
	else if(top < -offset) Reset();
	else if(bottom > offset) Reset();
}


void SpaceShip::Draw()
{

	float colors[3][3] =
	{
		{0.75f, 0.25f, 0.25f},
		{0.25f, 0.75f, 0.25f},
		{0.75f, 0.75f, 0.25f},
	};

	glColor3f(colors[color][0], colors[color][1], colors[color][2]);
	TgaTexture::DrawQuad(x, y, spaceShipSize, spaceShipSize, 0.0f);
}
