# ifndef ROCKET_H
# define ROCKET_H

# include "SpaceShip.h"
# include "TgaTexture.h"
# include "MissileManager.h"



class Rocket
{
	float x;
	float y;
	float theta;
	float timeLeft;
	float smokeTimeLeft;
	bool  gameOver;

	TgaTexture		idleTexture;
	TgaTexture		shootingTexture;
	TgaTexture		smokeTexture;

	MissileManager	missileManager;
	
	void DrawSmoke();

public:

	Rocket();

	void Init();

	void Draw();
	
	void Update(float deltaTime, AsteroidManager* asteroidManager, SpaceShip* ship);

	void Shoot();

	void Progress();

	void OnMouseMove(float x1, float y1);

	void Relocate(float x1, float y1);	
};
# endif //ROCKET_H