# include <random>
# include <GL/glut.h>

# include "Utils.h"


float GetRandomValue(float min, float max)
{
	int number = std::rand();
	float value = float(number) / float(RAND_MAX);

	return min + value*(max-min);
}

int GetRandom(int limit)
{
	return rand() % limit;
}


float TriangleWave(float time, float maxTime, float min, float max)
{
	float halfTime = maxTime / 2.0f;

	float p = 1.0f - (fabs(halfTime - time)/halfTime);

	return min + p*(max - min);
}


void SetColor(int color)
{
	float colors[6][3] =
	{
		{0.75f, 0.25f, 0.25f},
		{0.25f, 0.75f, 0.25f},
		{0.75f, 0.75f, 0.25f},
		{0.25f, 0.75f, 0.75f},
		{0.75f, 0.25f, 0.75f},
		{0.75f, 0.75f, 0.75f},
	};


	color %= 6;
	glColor3f(colors[color][0], colors[color][1], colors[color][2]);
}