# include "AlienGun.h"


void AlienGun::Add(float x1, float y1, float x2, float y2)
{
	bullets.push_back(Bullet(x1, y1, x2, y2));
}


void AlienGun::Init()
{
	bulletImage.Init("missile.tga");
}


void AlienGun::Reset()
{
	bullets.clear();
}



void AlienGun::Update(float deltaTime)
{
	for(size_t i = 0; i < bullets.size(); i++)
	{
		bullets[i].Update(0.01f);
	}
}



bool AlienGun::CheckCollision(float x, float y, float size)
{
	for(size_t i = 0; i < bullets.size(); i++)
	{
		if(bullets[i].CheckCollision(x, y, size)) return true;
	}

	return false;
}


void AlienGun::Draw()
{
	bulletImage.Activate();

	for(size_t i = 0; i < bullets.size(); i++)
	{
		bullets[i].Draw();
	}
}