# include "GUI.h"


GUI::GUI() : x(0.0f), y(0.0f), sizeX(0.25f), sizeY(0.125f), active(true), onClick(0)
{
}



void GUI::Activate()
{
	active = true;
}



void GUI::Init(float x1, float y1, float sizeX1, float sizeY1, EventHandler function)
{
	onClick = function;

	x = x1;
	y = y1;
	sizeX = sizeX1;
	sizeY = sizeY1;

	image.Init("start_normal.tga");
}



void GUI::HandleMouseClick(float x1, float y1)
{
	float left = x - sizeX;
	float right = x + sizeX;
	float top = y + sizeY;
	float bottom = y - sizeY;

	if(x1 < left) return;
	if(y1 < bottom) return;
	if(x1 > right) return;
	if(y1 > top) return;

	if(onClick)
		onClick();
}


void GUI::Draw()
{
	image.Activate();
	glColor3f(1.0f, 1.0f, 1.0f);
	TgaTexture::DrawQuad(x, y, sizeX, sizeY, 0.0f);
}


void GUI::HandleMouseMove(float x1, float y1)
{
}