# ifndef ROCKET_H
# define ROCKET_H

# include "Utils.h"
# include "SpaceShip.h"
# include "TgaTexture.h"
# include "SmokeEffect.h"
# include "MissileManager.h"



class Rocket
{
	float x;
	float y;
	float theta;
	float timeLeft;
	float fireTimeLeft;
	int   livesLeft;

	TgaTexture		idleTexture;
	TgaTexture		shootingTexture;
	TgaTexture		fire;
	SmokeEffect		smoke;

	MissileManager	missileManager;
	
	void DrawSmoke();
	void DrawLives();

	void ReduceHealth(SpaceShip* ship);

public:
	bool  gameOver;

	Rocket();

	void Init();

	void Draw();
	
	bool Update(float deltaTime, AsteroidManager* asteroidManager, SpaceShip* ship);

	void Shoot();

	void Progress();

	void OnMouseMove(float x1, float y1);

	void Relocate(float x1, float y1);	
};
# endif //ROCKET_H